# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
from .dataset_response import DatasetResponseParams
from .run_version_response import RunVersionResponseParams
import datetime as dt
from ..types.user_response import UserResponse
from ..types.evaluation_status import EvaluationStatus


class EvaluationRunResponseParams(typing_extensions.TypedDict):
    id: str
    """
    Unique identifier for the Run.
    """

    dataset: typing_extensions.NotRequired[DatasetResponseParams]
    """
    The Dataset used in the Run.
    """

    version: typing_extensions.NotRequired[RunVersionResponseParams]
    """
    The version used in the Run.
    """

    orchestrated: bool
    """
    Whether the Run is orchestrated by Humanloop.
    """

    added_at: dt.datetime
    """
    When the Run was added to the Evaluation.
    """

    created_at: dt.datetime
    """
    When the Run was created.
    """

    created_by: typing_extensions.NotRequired[UserResponse]
    """
    The User who created the Run.
    """

    status: EvaluationStatus
    """
    The status of the Run.
    """

    control: bool
    """
    Stats for other Runs will be displayed in comparison to the control Run.
    """
