# This file was auto-generated by Fern from our API Definition.

from __future__ import annotations
from ..core.unchecked_base_model import UncheckedBaseModel
from .evaluator_response import EvaluatorResponse
from .flow_response import FlowResponse
from .monitoring_evaluator_response import MonitoringEvaluatorResponse
from .prompt_response import PromptResponse
from .tool_response import ToolResponse
from .version_deployment_response import VersionDeploymentResponse
from .version_id_response import VersionIdResponse
import typing
import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2
from ..core.pydantic_utilities import update_forward_refs


class ListFlows(UncheckedBaseModel):
    records: typing.List[FlowResponse] = pydantic.Field()
    """
    The list of Flows.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow


update_forward_refs(EvaluatorResponse, ListFlows=ListFlows)
update_forward_refs(FlowResponse, ListFlows=ListFlows)
update_forward_refs(MonitoringEvaluatorResponse, ListFlows=ListFlows)
update_forward_refs(PromptResponse, ListFlows=ListFlows)
update_forward_refs(ToolResponse, ListFlows=ListFlows)
update_forward_refs(VersionDeploymentResponse, ListFlows=ListFlows)
update_forward_refs(VersionIdResponse, ListFlows=ListFlows)
