# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import pydantic
import typing
from .run_stats_response_evaluator_stats_item import RunStatsResponseEvaluatorStatsItem
from .evaluation_status import EvaluationStatus
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class RunStatsResponse(UncheckedBaseModel):
    """
    Stats for a Run in the Evaluation.
    """

    run_id: str = pydantic.Field()
    """
    Unique identifier for the Run.
    """

    version_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    Unique identifier for the evaluated Version.
    """

    batch_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    Unique identifier for the batch of Logs to include in the Evaluation.
    """

    num_logs: int = pydantic.Field()
    """
    The total number of existing Logs in this Run.
    """

    evaluator_stats: typing.List[RunStatsResponseEvaluatorStatsItem] = pydantic.Field()
    """
    Stats for each Evaluator Version applied to this Run.
    """

    status: EvaluationStatus = pydantic.Field()
    """
    The current status of the Run.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
